package com.prolog.eis.service.outbound.impl;

import com.prolog.eis.dao.outbound.BizOutboundTaskDetailItemMapper;
import com.prolog.eis.model.out.BizOutboundTaskDetailItem;
import com.prolog.eis.service.outbound.BizOutboundTaskDetailItemService;
import com.prolog.framework.core.restriction.Criteria;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 出库物料订单详情表-服务实现类
 * @date 2023-10-12 10:44
 */
@Service
public class BizOutboundTaskDetailItemServiceImpl implements BizOutboundTaskDetailItemService {

    @Autowired
    private BizOutboundTaskDetailItemMapper bizOutboundTaskDetailItemMapper;

    /**
     * 新增数据
     *
     * @param bizOutboundTaskDetailItem 出库物料订单详情表
     */
    @Override
    public long save(BizOutboundTaskDetailItem bizOutboundTaskDetailItem) {
        return bizOutboundTaskDetailItemMapper.save(bizOutboundTaskDetailItem);
    }

    /**
     * 新增批量数据
     *
     * @param bizOutboundTaskDetailItemList 出库物料订单详情表
     */
    @Override
    public long saveBatch(List<BizOutboundTaskDetailItem> bizOutboundTaskDetailItemList) {
        return bizOutboundTaskDetailItemMapper.saveBatch(bizOutboundTaskDetailItemList);
    }

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<BizOutboundTaskDetailItem> findByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDetailItemMapper.findByMap(paramMap, BizOutboundTaskDetailItem.class);
    }

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    @Override
    public BizOutboundTaskDetailItem findOneByMap(Map<String, Object> paramMap) {
        List<BizOutboundTaskDetailItem> dataList = findByMap(paramMap);
        if(dataList.isEmpty()) {
            return null;
        }
        return dataList.get(0);
    }

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<BizOutboundTaskDetailItem> findByCriteria(Criteria criteria) {
        return bizOutboundTaskDetailItemMapper.findByCriteria(criteria);
    }

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public BizOutboundTaskDetailItem findById(int id) {
        return bizOutboundTaskDetailItemMapper.findById(id, BizOutboundTaskDetailItem.class);
    }

    /**
     * 修改数据
     *
     * @param bizOutboundTaskDetailItem 实例对象
     */
    @Override
    public long update(BizOutboundTaskDetailItem bizOutboundTaskDetailItem) {
        return bizOutboundTaskDetailItemMapper.update(bizOutboundTaskDetailItem);
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    @Override
    public long deleteById(int id) {
        return bizOutboundTaskDetailItemMapper.deleteById(id, BizOutboundTaskDetailItem.class);
    }

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    @Override
    public long deleteByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDetailItemMapper.deleteByMap(paramMap, BizOutboundTaskDetailItem.class);
    }

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    @Override
    public long findCountByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDetailItemMapper.findCountByMap(paramMap, BizOutboundTaskDetailItem.class);
    }
}
